<html>
<body>


<h3> 1. Introduction </h3>
	<p> 
		SBIP2 is an IDE including project management, model edition, compilation, simulation, and statistical analysis for BIP models.
		It is based on the BIP framework for modeling in a component-based fashion.
		The current release allows using different BIP engines, namely, untimed BIP,
		and the new Stochastic Real-Time BIP.
	</p>




	<p>
<figure>
  <img src="img/tool2.png" alt="Tool architecture" width="600" height="300"/>  
</figure>

</p>


<p>
The tool relies on five modules, namely, a Stochastic Simulation Engine, a Monitoring module, a SMC Engine, a Rare-Event engine, a Parametric Exploration module plus additional data structures. The stochastic engine encapsulates the behavior of an executable model simulator and is used to produce (random) execution traces on demand. The monitor is
used to evaluate properties on trace. The SMC engine implements the main sta-
tistical model-checking loop depending on the statistical method used, namely
hypothesis testing or probability estimation. The rare-event engine implements the Importance Splitting technique to estimate the probability of rare properties. Finally, the parametric exploration
module coordinates the evaluation of a parametric property.
	</p>

	<p>
		Note that the tool and the bip engines were developed using Java 7 and work only on GNU/Linux OS.
		The Java Runtime Environment 7 is available for download <a href="http://www.oracle.com/technetwork/java/javase/downloads/java-archive-downloads-javase7-521261.html">here</a>.
		After installing java 7, make sure that it is your default java.
		
	</p>

	<p>
		The following sections explain how to install the SBIP v2.0, the GNU scientific library and finally the BIP engines. 
	</p>

<h3> 2. SBIP v2.0 setup </h3>
	<p> 
		The tool is released with an installation file named 'install.sh'.
		To install the tool, open a terminal and run the following command : 
		<pre><code>$ ./install.sh</code></pre>
		The installation generates a desktop launcher that allows to start the tool.
	</p>


<h3> 3. GNU Scientific Library setup </h3>
	<p> 
		GSL is a numerical library that we use to sample probability density functions.
		It is released under a GNU General Public License.
		This library can be downloaded <a href="ftp://ftp.gnu.org/gnu/gsl/">here</a> and installed by running the command below in the downloaded folder with the required priviliges:
		<pre><code>$./configure; make; make install</code></pre>
	</p>

	<p>
		NB: In some cases, an error may happen while loading the library, checking for 'libgsl.so.0' instead of 'libgsl.so'. This can be solved by creating the following link: 
		<pre><code>$ ln /usr/local/lib/libgsl.so /usr/local/lib/libgsl.so.0</code></pre>
	</p>

<h3> 4. Simulation engines setup </h3>
	<p> 
		The BIP engines are available to download online:
		<ul>
			<li> Untimed BIP : <a href="http://www-verimag.imag.fr/New-BIP-tools.html">download</a></li>
			<li> Stochastic Real-Time BIP : <a href="http://www-verimag.imag.fr/BIP-SMC-A-Statistical-Model-Checking.html">download</a></li>
		</ul>
		Note that BIP model compilation requires to install the packets <i>g++</i> and <i>cmake</i>. In a terminal, run the command :
	 	<pre><code>$ sudo apt-get install g++ cmake </code></pre>

	</p>

	<p>
		After downloading the engines, one has to configure the BIP compilation in the SBIP framework.
		This consists of updating the compilation scripts by locating the installed BIP engines.
		To configure the Stochastic RT-BIP engine for example, follow these steps:
		<ol>
			<li> Open SBIP by clicking on the launcher </li>
			<li> In the toolbar, click on the button with the tool tip text 'Configure BIP compilation scripts'.</li>
			<li> In the dialog window that opens, select 'Stochastic RT-BIP' in the combo box, then click 'ok'.
				This will open an edition tab that contains the corresponding script.</li>
			<li> At the line preceding the line <code>source  setup.sh reference-engine</code>, update the current <code>cd</code> line so that it points to the folder 				'distribution' of the BIP engine you installed. The result should be :
				<pre><code>	cd /path/to/bip/engine/folder/distribution
	source  setup.sh reference-engine</code></pre></li>
			<li> Save the changes </li>
			<li> Close the edition tab </li>

		</ol>
	
	</p>



You can now start using the tool.
</body>

</html>
